#pragma once
#include "nstd_prefix.h"

namespace nstd {

	template< typename T=None > class Noncopyable {
		Noncopyable( Noncopyable const& );
		Noncopyable& operator=( Noncopyable const& );	
	protected:
		Noncopyable() {}
	};
	
	template< typename T > struct Counted {
		static int gCount;

		static void IncreaseCountedInstance() { ++gCount; }
		static void DecreaseCountedInstance() { --gCount; }

		Counted() { T::IncreaseCountedInstance(); }
		Counted( Counted const& ) { T::IncreaseCountedInstance(); }
		~Counted() { T::DecreaseCountedInstance(); }
	};
	template< typename T > int Counted<T>::gCount = 0;


	
	/*
template<typename T> struct Default { T operator()() { return T(); } };
template<typename T, T (*F)()> struct Call { T operator()() { return F(); } };
template<int N> struct Integer { int operator()() { return N; } };

template< typename X, typename Value = Default<X> >
class initialized {
public:
  initialized() : x(Value()()) {}
  initialized(const X& x_) : x(x_) {}
  const X& get() const { return x; }
  operator const X&() const { return x; }
  operator X&() { return x; }
private:
  X x;
};

//You might use it like this:
struct Pi { double operator()() { return 3.14; } }; //Exactly
const char* init_message() { return "initial message"; }
Point top_middle() { return Point(screen_width()/2, 0); }

struct X {
  initialized<int> a;
  initialized<int, Integer<42> > b;
  initialized<double> c;
  initialized<double, Pi> d;
  initialized<std::string> e;
  initialized<std::string, Call<const char*, init_message> > f;
  initialized<Point> g;
  initialized<Point, Call<Point,top_middle> > h;
  X() {}
};
*/
	
}